* This is a small demonstrative example 1 - version 1
* Is the same than the others versions of the same problem, but in this case
* 6 binary variables are used to handle the disjunction terms.
* The model uses IF..THEN..ELSIF.. sentence for posing disjunctions

* Three jobs (A,B,C) must be executed sequentially in three steps, but
* not all jobs require all the stages. The objective is to obtain the
* sequence of tasks which minimizes the completion time. Once a job has
* started it cannot be interrupted.
*
* The objective is to obtain the sequence of task, which minimizes the
* completion time.
*
* Ref: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.

SET J jobs /A,B,C/;
* next set is created to hanble disjunction terms:
* AC means A preceeds C, CA means C preceeds A, etc.
SET I set for variables handling disjunctions terms/AC,CA,BC,CB,AB,BA/ ;

BINARY VARIABLES Y(I);
POSITIVE VARIABLES X(J),T;
VARIABLE Z;
equatIONS equat1, equat2, equat3, equat4, equat5, equat6,
          equat7, equat8, equat9, DUMMY, OBJECTIVE;

equat1.. T =G= X('A') + 8;
equat2.. T =G= X('B') + 5;
equat3.. T =G= X('C') + 6;
equat4.. X('A')-X('C') =L= -5;
equat5.. X('C')-X('A') =L= -2;
equat6.. X('B')-X('C') =L= -1;
equat7.. X('C')-X('B') =L= -6;
equat8.. X('A')-X('B') =L= -5;
equat9.. X('B')-X('A') =L= 0;
DUMMY.. SUM(I, Y(I)) =G= 0;

OBJECTIVE.. Z =E= T;

option mip=osl;
option limcol=0;
option limrow=0;
option optcr=0.;
option optca=0.;

X.UP(J)=10000000.;

$ONECHO > "%lm.info%"
DISJUNCTION D1,D2,D3;

D1 IS
IF Y('AC') THEN
        equat4;
ELSIF Y('CA') THEN
        equat5;
ENDIF;

D2 IS
IF Y('BC') THEN
        equat6;
ELSIF Y('CB') THEN
         equat7;
ENDIF;

D3 IS
IF Y('AB') THEN
        equat8;
ELSIF Y('BA') THEN
        equat9;
ENDIF;

$offecho

OPTION MIP=lmchull;
MODEL PEQUE1 /ALL/;
SOLVE PEQUE1 USING MIP MINIMIZING Z;
