* This is a small demonstrative example 1 - version 2
* It is the same than the other versions of the same problem, but in this case
* 3 variables are used to handle the disjunction terms
* The model uses IF..THEN..ELSE.. sentence for posing disjunctions

* Three jobs (A,B,C) must be executed sequentially in three steps, but
* not all jobs require all the stages. The objective is to obtain the
* sequence of tasks which minimizes the completion time. Once a job has
* started it cannot be interrupted.
*
* The objective is to obtain the sequence of task, which minimizes the
* completion time.
*
* Ref: Raman & Grossmann, Comp. & Chem. Eng., 18, 7, p.563-578, 1994.

SET J /A,B,C/;
BINARY VARIABLES Y(J);
POSITIVE VARIABLES X(J),T;
VARIABLE Z;
EQUATIONS EQUAT1, EQUAT2, EQUAT3, EQUAT4, EQUAT5, EQUAT6,
          EQUAT7, EQUAT8, EQUAT9,DUMMY, OBJECTIVE;

EQUAT1.. T =G= X('A') + 8;
EQUAT2.. T =G= X('B') + 5;
EQUAT3.. T =G= X('C') + 6;
EQUAT4.. X('A')-X('C')+ 5 =L= 0;
EQUAT5.. X('C')-X('A')+ 2 =L= 0;
EQUAT6.. X('B')-X('C')+ 1 =L= 0;
EQUAT7.. X('C')-X('B')+ 6 =L= 0;
EQUAT8.. X('A')-X('B')+ 5 =L= 0;
EQUAT9.. X('B')-X('A') =L= 0;
DUMMY.. SUM(J, Y(J)) =G= 0;

OBJECTIVE.. Z =E= T;

X.UP(J)=20.;

$ONECHO > "%lm.info%"
DISJUNCTION D1,D2,D3;

 D1 IS
IF Y('A') THEN
        EQUAT4;
ELSE
        EQUAT5;
ENDIF;

 D2 is
IF Y('B') THEN
        EQUAT6;
ELSE
        EQUAT7;
ENDIF;

 D3 IS IF Y('C') THEN
        EQUAT8;
ELSE
        EQUAT9;
ENDIF;

$offecho

OPTION MIP=lmchull;
OPTION LIMCOL=0;
OPTION LIMROW=0;
OPTION OPTCR=0.0;
MODEL PEQUE1 /ALL/;
SOLVE PEQUE1 USING MIP MINIMIZING Z;